using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using C1.Win.C1FlexGrid;

namespace UnboundColumns
{
	public class Form1 : System.Windows.Forms.Form
	{
		private C1.Win.C1FlexGrid.C1FlexGrid _flex;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this._flex = new C1.Win.C1FlexGrid.C1FlexGrid();
            ((System.ComponentModel.ISupportInitialize)(this._flex)).BeginInit();
            this.SuspendLayout();
            // 
            // _flex
            // 
            this._flex.ColumnInfo = "10,1,0,0,0,85,Columns:";
            this._flex.Dock = System.Windows.Forms.DockStyle.Fill;
            this._flex.Location = new System.Drawing.Point(0, 0);
            this._flex.Name = "_flex";
            this._flex.Size = new System.Drawing.Size(685, 547);
            this._flex.StyleInfo = resources.GetString("_flex.StyleInfo");
            this._flex.TabIndex = 0;
            this._flex.UseCompatibleTextRendering = true;
            this._flex.GetUnboundValue += new C1.Win.C1FlexGrid.UnboundValueEventHandler(this._flex_GetUnboundValue);
            this._flex.SetUnboundValue += new C1.Win.C1FlexGrid.UnboundValueEventHandler(this._flex_SetUnboundValue);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(685, 547);
            this.Controls.Add(this._flex);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "C1FlexGrid: Unbound checkbox column";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this._flex)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable();
			dt.Columns.Add("CustomerID", typeof(int));
			dt.Columns.Add("ContactName", typeof(string));
			dt.Columns.Add("Designation", typeof(string));
			dt.Columns.Add("Country", typeof(string));

			//Sample Data
			dt.Rows.Add(1, "Maria Anders", "Sales Representative", "Spain");
			dt.Rows.Add(2, "Ana Trujillo", "Sales Associate", "Mexico");
			dt.Rows.Add(3, "Antonio Moreno", "Owner", "Ireland");
			dt.Rows.Add(4, "Thomas Hardy", "Sales Representative", "UK");
			dt.Rows.Add(5, "Patricio Simpson", "Marketing Manager", "Germany");
			dt.Rows.Add(6, "Paolo Accorti", "Sales Representative", "Spain");
			dt.Rows.Add(7, "Martine Ranc", "Owner", "Mexico");
			dt.Rows.Add(8, "Elizabeth Brown", "Marketing Manager", "UK");
			dt.Rows.Add(9, "Jaime Yorres", "Order Administrator", "Austria");
			dt.Rows.Add(10, "Yvonne Moncada", "Marketing Manager", "Mexico");
			dt.Rows.Add(11, "Helen Bennett", "Owner/Marketing", "Ireland");
			dt.Rows.Add(12, "Sergio Gutirrezy", "Order Administrator", "Brazil");

			_flex.DataSource = dt;
			_flex.AutoSizeCols();
			// add unbound column
			Column col = _flex.Cols.Insert(1);
			col.Name = col.Caption = "Select Row(s)";
			col.DataType = typeof(bool);
		}

		// keep unbound values in a hashtable
		Hashtable _hash = new Hashtable();

		// get value from hashtable using CustomerID as key
		void _flex_GetUnboundValue(object sender, C1.Win.C1FlexGrid.UnboundValueEventArgs e)
		{
			DataRowView drv = (DataRowView)_flex.Rows[e.Row].DataSource;
			e.Value = _hash[drv["CustomerID"]];
		}

		// store value in hashtable using CustomerID as key
		void _flex_SetUnboundValue(object sender, C1.Win.C1FlexGrid.UnboundValueEventArgs e)
		{
			DataRowView drv = (DataRowView)_flex.Rows[e.Row].DataSource;
			_hash[drv["CustomerID"]] = e.Value;

			if(Convert.ToBoolean(e.Value))
			{
				_flex.Rows[e.Row].Selected = true;
			}
			else
			{
				_flex.Rows[e.Row].Selected = false;
			}
		}
    }
}
